package com.backend.glowhouse.controller;

import com.backend.glowhouse.model.Device;
import com.backend.glowhouse.model.DeviceRegistrationRequest;
import com.backend.glowhouse.repository.device.DeviceRepository;
import com.backend.glowhouse.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("api/device")
public class DeviceController {
    private DeviceRepository deviceRepository;
    private UserRepository userRepository;

    @Autowired
    public DeviceController(DeviceRepository deviceRepository, UserRepository userRepository) {
        this.deviceRepository = deviceRepository;
        this.userRepository = userRepository;
    }

    @PostMapping("/registerDevice")
    @PreAuthorize("hasRole('USER')")
    public Boolean registerDevice(@RequestBody DeviceRegistrationRequest deviceRegistrationRequest) {
        String deviceId = deviceRegistrationRequest.getDeviceId();
        String username = deviceRegistrationRequest.getUsername();

        Device deviceToRegister = deviceRepository.updateDeviceAssignUserAndSetRegisteredTrue(deviceId, username);
        Boolean wasRegistered = userRepository.updateUserAssignDevice(username, deviceToRegister);

        return wasRegistered;
    }
}
